;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-intermediate-lambda-reader.ss" "lang")((modname skyscrapers) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #f #t none #f ())))
;; Data definitions
;;
;; A Cell is a (union Nat[>0] '?)
;;
;; A Grid is a (ne-listof (ne-listof Cell))
;; A ClueSet is a (ne-listof Nat[>0])

(define-struct state (grid left right top bottom))
;; A State is a (make-state Grid ClueSet ClueSet ClueSet ClueSet)


;; /////////////////////// 1 ///////////////////////

;; visibility-num/acc: (listof Cell) Nat -> Nat
;; 

(define (visibility-num/acc loc tallest-sofar)
  (cond
    [(empty? loc) 0]
    [(symbol? (first loc))
     (visibility-num/acc (rest loc) tallest-sofar)]
    [(> (first loc) tallest-sofar)
     (add1 (visibility-num/acc (rest loc) (first loc)))]
    [else
     (visibility-num/acc (rest loc) tallest-sofar)]))


;; visibility-number: (listof Cell) -> Nat
;; Compute the visibility number of a list of Cells (loc).
;; The numeric entries should not have any duplicates.
;;
;; Examples:
(check-expect (visibility-number empty) 0)
(check-expect (visibility-number '(4 ? 6 5 ? 9)) 3)
(check-expect (visibility-number '(4 3 ? 1)) 1)
(check-expect (visibility-number '(? ? ? ?)) 0)

(define (visibility-number loc)
  (visibility-num/acc loc 0))

;; Tests:
(check-expect (visibility-number '(? 2 ? 4 ? 1)) 2)
(check-expect (visibility-number '(1 ? 3 5 ?)) 3)
(check-expect (visibility-number '(4 ? ? ?)) 1)
(check-expect (visibility-number '(? ? ? 3)) 1)


;; /////////////////////// 2 ///////////////////////

;; Let n represent the length of the list lov.
;; Let S represent the set of numbers between 1 and n
;; that do not currently appear in lov.

;; not-in-lov: (listof Cell) Nat[>0] -> (listof Nat[>0])
;; Produces a list of numbers between 1 and n in ascending order
;; that are not visible in lov.
;; Examples:
(check-expect (not-in-lov empty 1) empty)
(check-expect (not-in-lov '(? ? ? 3 1) 1) '(2 4 5)) 
(check-expect (not-in-lov '(1 2 3 ? ?) 1) '(4 5))
(check-expect (not-in-lov '(? ? ? ?) 1) '(1 2 3 4))
              
(define (not-in-lov lov x)
  (cond
    [(or (empty? lov) (> x (length lov))) empty]
    [(member? x lov) (not-in-lov lov (add1 x))]
    [else (cons x (not-in-lov lov (add1 x)))]))

;; Tests for not-in-lov
(check-expect (not-in-lov '(5 ? ? ? ?) 1) '(1 2 3 4))
(check-expect (not-in-lov '(3 1 ? ?) 1) '(2 4))


;; not-in-lov/rev: (listof Cell) Nat -> (listof Nat[>0])
;; Produces a list of numbers between 1 and n in descending order
;; that are not visible in lov.
;; Examples:
(check-expect (not-in-lov/rev empty 1) empty)
(check-expect (not-in-lov/rev '(5 3 ? ? ?) 5) '(4 2 1))
(check-expect (not-in-lov/rev '(? ? ? 4 2) 5) '(5 3 1))
(check-expect (not-in-lov/rev '(? ? ? ?) 4) '(4 3 2 1))

(define (not-in-lov/rev lov x)
    (cond
      [(or (empty? lov) (= x 0)) empty]
      [(member? x lov) (not-in-lov/rev lov (sub1 x))]
      [else (cons x (not-in-lov/rev lov (sub1 x)))]))

;; Tests for not-in-lov/rev:
(check-expect (not-in-lov/rev '(4 ? ? ?) 4) '(3 2 1))
(check-expect (not-in-lov/rev '(1 ? ? ?) 4) '(4 3 2))


;; fill-cells (listof Cell) (listof Nat[>0]) -> (listof Nat[>0])
;; Produces a list where the empty spaces of lov have been filled
;; by elements in S
;; Examples:
(check-expect (fill-cells empty empty) empty)
(check-expect (fill-cells '(3 1 2) empty) '(3 1 2))
(check-expect (fill-cells '(? ? ? 3 5) '(1 2 4)) '(1 2 4 3 5))
(check-expect (fill-cells '(4 1 ? ? ?) '(5 3 2)) '(4 1 5 3 2))
(check-expect (fill-cells '(? ? ? ?) '(1 2 3 4)) '(1 2 3 4))

(define (fill-cells lov s)
  (cond
    [(empty? lov) empty]
    [(symbol? (first lov))
     (cons (first s) (fill-cells (rest lov) (rest s)))]
    [else (cons (first lov) (fill-cells (rest lov) s))]))

;; Tests for vis-max:
(check-expect (fill-cells '(1 2 5 ? ?) '(3 4)) '(1 2 5 3 4))
(check-expect (fill-cells '(? ? 3 5 4) '(2 1)) '(2 1 3 5 4))
(check-expect (fill-cells '(? ? ?) '(3 2 1)) '(3 2 1))
              

;; feasible-visibility? : (listof Cell) Nat -> Boolean
;; Given a partially filled in row lov and a natural number vis 
;; that counts the number of towers that are supposed to be
;; visible, is it possible to fill in the blanks in lov so that
;; the desired visibility number is attained?  Assume that the
;; numeric entries in lov are in a contiguous block at the start
;; or end of the list.
;; Examples:
(check-expect (feasible-visibility? '(3 ? ? ?) 2) true)
(check-expect (feasible-visibility? '(2 1 ? ?) 4) false)
(check-expect (feasible-visibility? '(? ? ? ?) 4) true)
(check-expect (feasible-visibility? '(? ? ? ?) 1) true)
(check-expect (feasible-visibility? '(? ? ? ?) 0) false)
(check-expect (feasible-visibility? '(? ? ? ?) 5) false)

(define (feasible-visibility? lov vis)
  (local
    [(define n (length lov))
     (define s (not-in-lov lov 1))
     (define s/rev (not-in-lov/rev lov n))
     (define vis-max (visibility-number (fill-cells lov s)))
     (define vis-min (visibility-number (fill-cells lov s/rev)))]
    (cond 
      [(>= vis vis-min) (<= vis vis-max)]
      [else false])))

;; Examples:
(check-expect (feasible-visibility? '(? ? 5 4 2) 1) false)
(check-expect (feasible-visibility? '(5 ? ? ? ?) 2) false)
(check-expect (feasible-visibility? '(? ? ? ? 5) 1) false)
(check-expect (feasible-visibility? '(? ? ? ? 5) 2) true)
(check-expect (feasible-visibility? '(? ? ? 2 5) 3) true)


;; /////////////////////// 3 ///////////////////////
;; mirror-grid: Grid -> Grid
;; horizonally mirrors the grid
;; Examples:
(check-expect (mirror-grid '((1 2 3)
                             (4 5 6)
                             (7 8 9)))
              '((3 2 1)
                (6 5 4)
                (9 8 7)))
(check-expect (mirror-grid empty) empty)
(define (mirror-grid a-grid)
  (cond
    [(empty? a-grid) empty]
    [else (cons (reverse (first a-grid)) (mirror-grid (rest a-grid)))]))
                           
;; transpose-grid: Grid -> Grid
;; transposes the given grid
;; Examples:

(check-expect (transpose-grid '((1 2 3)
                                (4 5 6)
                                (7 3 9))) 
              '((1 4 7)
                (2 5 3)
                (3 6 9)))

(define (transpose-grid grid)
  (apply map list grid))

;; Tests for transpose-grid
(check-expect (transpose-grid '((? ? 3)
                                (2 ? ?)
                                (? 1 ?)))
              '((? 2 ?)
                (? ? 1)
                (3 ? ?)))

;; valid-from-left?: Grid ClueSet -> Boolean
;; Produces true if the left visibility number of every row in the state
;; is valid.
;; Example:
(check-expect (valid-from-left? '((? ? 3)
                                 (? ? ?) 
                                 (? ? ?)) 
                                '(3 1 1)) true)

(check-expect (valid-from-left? '((? ? 3)
                                 (? ? ?) 
                                 (? ? ?)) 
                                '(1 1 1)) false)

(check-expect (valid-from-left? empty empty) true)

(define (valid-from-left? grid left-clueset)
  (cond
    [(empty? grid) true]
    [else
     (and (feasible-visibility? (first grid) (first left-clueset))
          (valid-from-left? (rest grid) (rest left-clueset)))]))

;; Tests for valid-from-left?:
(check-expect (valid-from-left? '((2 ? ?)
                                 (3 ? ?) 
                                 (? ? ?)) 
                                '(2 1 2)) true)

(check-expect (valid-from-left? '((2 ? ?)
                                 (3 ? ?) 
                                 (1 ? ?)) 
                                '(2 2 2)) false)
 
;; valid-state? : State -> Boolean
;; Determine whether the passed-in State a-state can still be legally
;; continued to produce a solution for the entire puzzle.  Rule out
;; any State in which there are duplicate entries in one row or column
;; and any State in which a row or column violates its visibility
;; constraints.
;; Examples:
(check-expect 
 (valid-state? 
  (make-state '((? ? 3)
                (? ? ?) 
                (? ? ?)) 
              '(1 2 1) 
              '(2 1 1) 
              '(1 1 1) 
              '(2 2 2))) false)
(check-expect
 (valid-state?
  (make-state '((? ? 3) 
                (? ? ?) 
                (? ? ?))
              '(3 1 1) 
              '(1 2 2) 
              '(1 1 1)
              '(2 2 2))) true)


(define (valid-state? a-state)
  (local
    [(define right-to-left (mirror-grid (state-grid a-state)))
     (define top-down (transpose-grid (state-grid a-state)))
     (define bottom-up (mirror-grid (transpose-grid (state-grid a-state))))]
    (and (valid-from-left? (state-grid a-state) (state-left a-state))
         (valid-from-left? right-to-left (state-right a-state))
         (valid-from-left? top-down (state-top a-state))
         (valid-from-left? bottom-up (state-bottom a-state)))))

;; Tests for valid-state?:
(check-expect 
 (valid-state? 
  (make-state '((? ? 3)
                (1 3 ?) 
                (? ? 1)) 
              '(2 2 2) 
              '(1 2 3) 
              '(2 2 1) 
              '(2 2 3))) true)
(check-expect 
 (valid-state? 
  (make-state '((? ? 3)
                (1 3 ?) 
                (? ? 1)) 
              '(2 2 2) 
              '(1 3 3) 
              '(2 2 1) 
              '(2 2 2))) false)



;; /////////////////////// 4 ///////////////////////
;; complete-state? : State -> Boolean
;; Determine whether the passed-in State a-state represents a solved
;; puzzle, i.e., one in which the grid has no unknowns left it in
;; (we assume that the puzzle is legal if this is the case).

; Examples:
(check-expect
 (complete-state?
  (make-state '((? 1 2) (3 2 1) (1 2 3))
              '(1 1 1) '(1 1 1) '(1 1 1) '(1 1 1))) false)
(check-expect
 (complete-state?
  (make-state '((1 2)
                (2 1))
              '(2 1) '(1 2) '(2 1) '(1 2))) true)

(define (complete-state? a-state)
  (andmap number? (foldr append empty (state-grid a-state))))

;; Tests for complete-state?
(check-expect 
 (complete-state? (make-state '((1 2 3) 
                                (4 5 6) 
                                (7 8 9))
                              '(3 3 3) '(1 1 1) '(3 3 3) '(1 1 1))) true)



;; /////////////////////// 5 ///////////////////////
;; foo: (listof Cell) Nat -> (listof Cell)
;; inserts (? ? ? ?) -> (n ? ? ?)
;; Examples:
;(check-expect (foo '(? ? ? ?) '(1 2 3 4)) '(1 ? ? ?))
;(check-expect (foo '(1 2 ? ?) '(1 2 3 4)) '(1 2 1 ?))
;
;(define (foo loc n)
;  (cond
;    [(symbol? (first loc)) (cons n (rest loc))]
;    [else (cons (first loc) (foo (rest loc) n))]))
;
;
;;; baz: Grid (listof Nat[>0]) -> (listof Grid)
;
;;; Examples:
;(define (baz grid lon)
;    (cond
;      [(member? '? (first grid))
;       (cons (cons (foo (first grid) (first lon)) (rest grid))
;             (baz grid (rest lon)))]
;      [else 
;       (cons (first grid) (baz (rest grid) lon))]))
;    
;          
;;; neighbouring-states: State (listof Grid) -> (listof State)
;;; Generates n candidate neighbouring States, one for each possible
;;; natural number that could be places in the empty cell (assuming the
;;; puzzle is of size n x n).
;;; Examples:
;(define (neighbouring-states state log)
;  (local [(define grid (state-grid state))
;          (define lo-grid (list-grid grid (build-list (length (first grid)) add1)))
;          (define l (state-left state))
;          (define r (state-right state))
;          (define t (state-top state))
;          (define b (state-bottom state))]
;    (cond
;      [(empty? log) empty]
;      [else
;       (cons (make-state (first log) l r t b) (neighbouring-states (rest log)))])))
;     
                    
;; neighbours : State -> (listof State)
;; Given a current State a-state, produce a list of all legal successor
;; states, according to the constraints laid out in the assignment (that
;; is, fill in the first non-numeric entry in the grid with each of the
;; legal numbers that can live in that spot.

;; Examples:
;(check-expect
; (neighbours
;  (make-state '((?)) '(1) '(1) '(1) '(1)))
; (list (make-state '((1)) '(1) '(1) '(1) '(1))))
;
;(check-expect
; (neighbours
;  (make-state
;   (make-list 4 (make-list 4 '?))
;   '(1 3 2 2) '(3 2 2 1) '(1 3 2 3) '(2 2 3 1)))
; (list (make-state '((4 ? ? ?) (? ? ? ?) (? ? ? ?) (? ? ? ?))
;                   '(1 3 2 2) '(3 2 2 1) '(1 3 2 3) '(2 2 3 1))))
;
(define (neighbours a-state)
  (filter valid-state? (...)))

;; Tests:




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; search: (X -> Boolean) (X -> (listof X)) X -> (union X false)
;; Solve a puzzle, given a current State.  Use depth-first search
;; with backtracking, assuming that the search space is acyclic. 
;; The parameters are:
;;  * at-end? -- a predicate that determines whether the given
;;      state is an end state of the search (i.e., a solution).
;;  * neighbours -- a function that maps a current state to a list
;;      of neighbouring states.
;;  * a-state -- the initial state.
;;
;; DO NOT MODIFY THIS FUNCTION.

(define (search at-end? neighbours a-state)
  (local
    [;; find-route: X -> (union X false)
     ;; Search outward from this configuration to see if there's a path
     ;; to a solution.
     (define (find-route a-state)
       (cond
         [(at-end? a-state) a-state]
         [else (find-route/list (neighbours a-state))]))
     
     ;; find-route/list: (listof X) -> (union X false)
     ;; Search outward from every configuration in the passed-in list of
     ;; configurations.  If any one of them leads to a solution, stop and
     ;; produce that solution.  Produce false if you run out of options.
     (define (find-route/list lostate)
       (cond
         [(empty? lostate) false]
         [else
          (local
            [(define cur (find-route (first lostate)))]
            (cond
              [(not (boolean? cur)) cur]
              [else (find-route/list (rest lostate))]))]))]
    (find-route a-state)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Sample puzzles for testing.  You can easily create more yourself by 
;; transcribing them from examples generated using the software mentioned
;; in the assignment.
;;

;; The puzzle that appears at the start of the assignment handout.
(define assignment-puzzle
  (make-state
   (make-list 4 (make-list 4 '?))
   '(1 3 2 2)
   '(3 2 2 1)
   '(1 3 2 3)
   '(2 2 3 1)))
(define assignment-puzzle-solution
  (make-state
   '((4 1 3 2) (2 3 4 1) (1 4 2 3) (3 2 1 4))
   (state-left assignment-puzzle)
   (state-right assignment-puzzle)
   (state-top assignment-puzzle)
   (state-bottom assignment-puzzle)))

(define puzzle-1 
  (make-state
   (make-list 4 (make-list 4 '?))
   '(1 2 2 3)
   '(3 3 1 2)
   '(1 2 3 2)
   '(3 2 1 2)))
(define puzzle-1-solution 
  (make-state
   '((4 3 1 2) (2 4 3 1) (3 1 2 4) (1 2 4 3))
   (state-left puzzle-1)
   (state-right puzzle-1)
   (state-top puzzle-1)
   (state-bottom puzzle-1)))

(define puzzle-2 
  (make-state
   (make-list 4 (make-list 4 '?))
   '(1 2 3 2)
   '(3 3 2 1)
   '(1 2 3 3)
   '(2 3 2 1)))
(define puzzle-2-solution 
  (make-state
   '((4 3 1 2) 
     (2 4 3 1) 
     (1 2 4 3) 
     (3 1 2 4))
   (state-left puzzle-2)
   (state-right puzzle-2)
   (state-top puzzle-2)
   (state-bottom puzzle-2)))

(define puzzle-3 
  (make-state
   (make-list 5 (make-list 5 '?))
   '(2 3 2 1 3)
   '(2 1 2 3 2)
   '(4 1 2 3 2) 
   '(2 5 2 1 2)))
(define puzzle-3-solution 
  (make-state
   '((1 5 2 3 4) 
     (3 4 1 2 5)
     (4 3 5 1 2)
     (5 2 3 4 1)
     (2 1 4 5 3))
   (state-left puzzle-3)
   (state-right puzzle-3)
   (state-top puzzle-3)
   (state-bottom puzzle-3)))

(define puzzle-4 
  (make-state
   (make-list 5 (make-list 5 '?))
   '(2 2 1 2 4)
   '(3 2 5 3 1)
   '(3 1 3 2 3) 
   '(3 3 2 3 1)))
(define puzzle-4-solution 
  (make-state
   '((1 5 2 4 3) 
     (3 2 1 5 4)
     (5 4 3 2 1)
     (4 1 5 3 2)
     (2 3 4 1 5))
   (state-left puzzle-4)
   (state-right puzzle-4)
   (state-top puzzle-4)
   (state-bottom puzzle-4)))

(define bonus-puzzle
  (make-state
   '((? ? ? ? ? ?)
     (? ? ? ? ? ?)
     (? ? ? ? ? ?)
     (? ? ? ? ? ?)
     (? ? ? ? ? ?)
     (? ? ? 2 ? ?))
   '(2 4 ? ? ? ?)
   '(4 ? 4 ? 2 2)
   '(? 2 ? ? ? 4)
   '(? ? ? ? 4 ?)))

;; Testing example:
;; (check-expect (search complete-state? neighbours puzzle-4) puzzle-4-solution)
